const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const leave_requests = sequelize.define(
    'leave_requests',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

start_at: {
        type: DataTypes.DATE,
      
      

      },

end_at: {
        type: DataTypes.DATE,
      
      

      },

duration: {
        type: DataTypes.DECIMAL,
      
      

      },

duration_unit: {
        type: DataTypes.ENUM,
      
      

        values: [

"day",


"hour"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"submitted",


"approved",


"rejected",


"cancelled"

        ],

      },

reason: {
        type: DataTypes.TEXT,
      
      

      },

submitted_at: {
        type: DataTypes.DATE,
      
      

      },

decision_at: {
        type: DataTypes.DATE,
      
      

      },

decision_comment: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  leave_requests.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.leave_requests.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.leave_requests.belongsTo(db.leave_types, {
      as: 'leave_type',
      foreignKey: {
        name: 'leave_typeId',
      },
      constraints: false,
    });

    db.leave_requests.belongsTo(db.employees, {
      as: 'approver',
      foreignKey: {
        name: 'approverId',
      },
      constraints: false,
    });

    db.leave_requests.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.leave_requests.hasMany(db.file, {
      as: 'attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.leave_requests.getTableName(),
        belongsToColumn: 'attachments',
      },
    });


    db.leave_requests.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.leave_requests.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return leave_requests;
};


